program Dipintegrator_2D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_2D
  use igrad3_period
  use change_jl
  use igrad2_eps
  use dottest
  use igrad2_period_eps


  implicit none
  integer 	                          :: n1, n2, n3, iter, i,time_slc
  real                                    :: q,eps_j
  real,    dimension (:,:), allocatable :: data_in
  real,    dimension (:),     allocatable :: hh,hh_1D
  real,    dimension (:,:),     allocatable :: hh_2D,hh_2D_trun
  real,    dimension (:,:,:), allocatable :: data_amp,data_phz,data_real
  real,    dimension (:,:,:), allocatable :: data_imag
  real,    dimension (:,:), allocatable :: px_mirr,pz_mirr,px
  real,    dimension  (2)   :: dot1,dot2       !miny, bin-size;
  call sep_init ()
  call from_history (n1,n2,n3, esize=4 )
  call from_param("eps_j",eps_j,1.)

  call igrad2_period_eps_init(10,10,.4)
  call dot_test (igrad2_period_eps_lop,100,200,dot1,dot2)


  do i=1,n3

     write(0,*) 'Dip integrator: processing gather ',i,'/',n3

     allocate (data_in (n1,n2)) 
     call sep_read (data_in) 

     allocate (px(n1,n2))

     px=data_in  ! x direction dip


     deallocate(data_in)
     allocate (px_mirr(n1,n2*2),pz_mirr(n1,n2*2))
     !%%%%%%%%%%%%% make mirror
     px_mirr(1:n1,1:n2)        = px(:,:)
     px_mirr(1:n1,n2+1:n2*2) = -1.*px_mirr(1:n1,n2:1:-1);

     pz_mirr=1.
     pz_mirr(n1,:)=-(n1-1)
     pz_mirr=0.

     deallocate(px)
     allocate(hh(n1*n2*2))


     call dipintegrate_2D (px_mirr,pz_mirr, hh,eps_j) 


     allocate(hh_2D(n1,2*n2))

     hh_2D=reshape(hh,(/n1,n2*2/))
     allocate(hh_2D_trun(n1,n2))
     hh_2D_trun=hh_2D(1:n1,1:n2)
     deallocate(hh_2D)
     call sep_write (hh_2D_trun)
     deallocate (hh,hh_2D_trun)
     deallocate(px_mirr,pz_mirr)
  end do

  call to_history ("n1",  n1)
  call to_history ("n2",  n2)
  call to_history ("n3",  n3)    
  call to_history ("esize",4)

  call sep_close()
  call exit (0)

end program Dipintegrator_2D











