program Dipintegrator_3D
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use dipinteg_3D
  use igrad3_period
  use change_jl

  implicit none
  integer 	                          :: n1, n2, n3, n3f, iter, i
  real                                    :: q
  real,    dimension (:,:,:), allocatable :: data_in
  real,    dimension (:),     allocatable :: hh
  real,    dimension (:,:,:), allocatable :: data_amp,data_phz,data_real
  real,    dimension (:,:,:), allocatable :: data_imag,px,py,pz
  real,    dimension (:,:,:), allocatable :: px_mirr,py_mirr,pz_mirr,hh_3D,hh_3D_trun
  
  call sep_init ()
  call from_history (n1,n2,n3, esize=4 )
  
  n3f=1
  
  do i=1,n3

     write(0,*) 'Dip integrator: processing gather #',i,'/',n3

     allocate (data_in (n1,n2,n3f)) 
     call sep_read (data_in) 
     
     allocate (px(n1,n2,n3f),py(n1,n2,n3f),pz(n1,n2,n3f))
     
     px=data_in  ! x direction dip
     py=1.       ! y direction dip
     pz=1.       ! set to 1's
     
     deallocate(data_in)
     allocate (px_mirr(n1,n2*2,n3f*2),py_mirr(n1,n2*2,n3f*2),pz_mirr(n1,n2*2,n3f*2))
     !%%%%%%%%%%%%% make mirror
     px_mirr(1:n1,1:n2,1:n3f)        = px(:,:,:)
     px_mirr(1:n1,1:n2,n3f+1:2*n3f)  = px(1:n1,1:n2,n3f:1:-1);
     px_mirr(1:n1,n2+1:n2*2,1:2*n3f) = -1.*px_mirr(1:n1,n2:1:-1,1:2*n3f);
     
     py_mirr(1:n1,1:n2,1:n3f)       = py(:,:,:);
     py_mirr(1:n1,n2+1:2*n2,1:n3f)  = py(1:n1,n2:1:-1,1:n3f);
     py_mirr(1:n1,1:2*n2,n3f+1:n3f*2)= -1.*py_mirr(1:n1,1:2*n2,n3f:1:-1);
     
     pz_mirr=1.
     pz_mirr(n1,:,:)=-(n1-1)
     
     pz=1.
     deallocate(px,py,pz)
     allocate(hh(n1*n2*n3f*4))
     
!     write(0,*) 'size',size(px), size(py), size(pz)
!     write(0,*) 'n1,n2,n3f',n1,n2,n3f          
     
     call dipintegrate_3D (px_mirr,py_mirr,pz_mirr, hh)
     allocate(hh_3D(n1,2*n2,2*n3f))
     call change_sub_to_3D(hh, hh_3D ,n1,2*n2,2*n3f)
     
     deallocate(hh)
     allocate(hh_3D_trun(n1,n2,n3f))
     hh_3D_trun=hh_3D(1:n1,1:n2,1:n3f)
     deallocate(hh_3D)
     call sep_write (hh_3D_trun)
     deallocate (hh_3D_trun)
     deallocate(px_mirr,py_mirr,pz_mirr)
  end do
  
  call to_history ("n1",  n1)
  call to_history ("n2",  n2)
  call to_history ("n3",  n3)    
  call to_history ("esize",4)
  
  call sep_close()
  call exit (0)
     
end program Dipintegrator_3D











