program Estimate_shift

  use sep
  use slowness_1D

  implicit none 
  integer                                 :: ndim, nt, nx, nh, nm, stat
  real                                    :: t0,dt,x0,dx,h0,dh,dm,mf,m0,maxoffset
  real,    dimension (:)    , allocatable :: model   ! Estimated velocity perturbations
  real,    dimension (:)    , allocatable :: data    ! CMP gathers
  real,    dimension (:)    , pointer     :: s0      ! Initial 1D velocity
  integer                                 :: j, verb
  integer, dimension (:)    , allocatable :: n
  real,    dimension (:)    , allocatable :: d, o

  call initpar  ()                   ! start processing parameters
  call sep_init (SOURCE)
  ndim=sep_dimension()
  allocate(n(ndim),o(ndim),d(ndim))
  
  call from_history('n',n)
  call from_history('d',d)
  call from_history('o',o)
  call from_param('verb',verb,0)
  call from_param('nh',nh)
  call from_param('dh',dh)
  call from_param('h0',h0)
  call from_param('nx',nx)
  call from_param('dx',dx)
  call from_param('x0',x0)
  
  nt=n(1);t0=o(1);dt=d(1) ! Time
  nm=n(2);m0=o(2);dm=d(2) ! CMP

  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*) '< = MODEL SPACE PARAMETERS= >'
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*) '< = o-time    = >',t0
  if (verb.ge.1) write(0,*) '< = d-time    = >',dt
  if (verb.ge.1) write(0,*) '< = n-time    = >',nt
  if (verb.ge.1) write(0,*) '< = o-cmp     = >',m0
  if (verb.ge.1) write(0,*) '< = n-cmp     = >',nm
  if (verb.ge.1) write(0,*) '< = d-cmp     = >',dm
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*) '< = DATA SPACE PARAMETERS = >'
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*) '< = o-time    = >',t0
  if (verb.ge.1) write(0,*) '< = d-time    = >',dt
  if (verb.ge.1) write(0,*) '< = n-time    = >',nt
  if (verb.ge.1) write(0,*) '< = o-offset  = >',h0
  if (verb.ge.1) write(0,*) '< = d-offset  = >',dh
  if (verb.ge.1) write(0,*) '< = n-offset  = >',nh
  if (verb.ge.1) write(0,*) '< = o-cmp     = >',x0
  if (verb.ge.1) write(0,*) '< = d-cmp     = >',dx
  if (verb.ge.1) write(0,*) '< = n-cmp     = >',nx
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*)
  
  allocate (data(nt*nh*nx), model(nt*nm), s0(nt))
     
  call sep_read(model)
  call sep_read(s0,'s0')

  call slowness_init(t0,dt,nt,x0,dx,nx,m0,dm,nm,h0,dh,nh,s0,verb)
  stat=slowness_lop(.false.,.false.,model,data)
  call slowness_close()
   
  call to_history("n2",nh)
  call to_history("d2",dh)
  call to_history("o2",h0)
   
  call to_history("n3",nx)
  call to_history("d3",dx)
  call to_history("o3",x0)

  call sep_write(data)

  deallocate (model,data,s0)
  
  call exit (0)
  
end program ESTIMATE_SHIFT
