program makevel

  use sep

  implicit none 
  integer                                 :: ndim, n2, i, verb
  real                                    :: d2,o2
  real,    dimension (:)    , allocatable :: in   
  integer, dimension (:)    , allocatable :: n
  real,    dimension (:)    , allocatable :: d, o
  real,    dimension (:,:)  , allocatable :: out

  call initpar  ()                   ! start processing parameters
  call sep_init (SOURCE)
  ndim=sep_dimension()
  allocate(n(ndim),o(ndim),d(ndim))
  
  call from_history('n',n)
  call from_history('d',d)
  call from_history('o',o)
  call from_param('verb',verb,0)
  call from_param('n2out',n2)
  call from_param('d2out',d2)
  call from_param('o2out',o2)
 
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*) '< = INPUT SPACE PARAMETERS= >'
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*) '< = o-time    = >',o(1)
  if (verb.ge.1) write(0,*) '< = d-time    = >',d(1)
  if (verb.ge.1) write(0,*) '< = n-time    = >',n(1)
  if (verb.ge.1) write(0,*) '< ========================= >'
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*) '< =========================== >'
  if (verb.ge.1) write(0,*) '< = OUTPUT SPACE PARAMETERS = >'
  if (verb.ge.1) write(0,*) '< =========================== >'
  if (verb.ge.1) write(0,*) '< = o-time    = >',o(1)
  if (verb.ge.1) write(0,*) '< = d-time    = >',d(1)
  if (verb.ge.1) write(0,*) '< = n-time    = >',n(1)
  if (verb.ge.1) write(0,*) '< = o-offset  = >',o2
  if (verb.ge.1) write(0,*) '< = d-offset  = >',d2
  if (verb.ge.1) write(0,*) '< = n-offset  = >',n2
  if (verb.ge.1) write(0,*) '< =========================== >'
  if (verb.ge.1) write(0,*)
  if (verb.ge.1) write(0,*)
  
  allocate (in(n(1)), out(n(1),n2))
  
  call sep_read(in)

  do i=1,n2
     out(:,i)=in
  end do

  call to_history("n2",n2)
  call to_history("d2",d2)
  call to_history("o2",o2)
  
  call sep_write(out)

  deallocate (in,out)
  
  call exit (0)
  
end program MAKEVEL
