program Puck_3D_sm
!
!Jesse's Puck driver - adapted from Morgan's Puck2

  use sep
  use puck_no_wind_smooth_mod
  
  implicit none
  
  real, pointer, dimension(:,:)	:: d, p1, p2,px,py, residual, coh, residualx, cohx, residualy, cohy, a1
  real							:: dx, dt,dy,y0,x0,t0,mesh2phys
  integer							:: nt, nx, ny,nwx,nwt,Morgan, wk,boxsz
  integer							:: it,ix,iy,i
  real, dimension(:,:)                                :: cp,dip
  
  !! hook up sep parameter input facility
  call sep_init(SOURCE)
  
  !! input parameters from history file
  call from_history("n1",nt); call from_history("n2",nx); call from_history("n3",ny)
  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dy)
  call from_history("o1",t0); call from_history("o2",x0); call from_history("o3",y0)
  
  !! input window parameters from parameters
  call from_param("nwt",nwt,1); call from_param("nwx", nwx,1)
  call from_param("Morgan",Morgan,0);  call from_param("wk",wk,1)
  call from_param("boxsz",boxsz,0);
  !! output parameters to history file
  call to_history( "n1", nt);  call to_history( "n2", nx);  call to_history( "n3", ny)
  call to_history( "d1", dt);  call to_history( "d2", dx);  call to_history( "d3", dy)
  call to_history( "o1", t0);  call to_history( "o2", x0);  call to_history( "o3", y0)
  
  call to_history("Morgan",Morgan); call to_history("wk",wk)
  
  !! allocate data and dip arrays
  allocate(d(nt,nx), p1(nt,nx), p2(nt,nx),px(nt,nx),py(nt,nx))
  allocate(residualx(nt,nx),cohx(nt,nx),residualy(nt,nx))
  allocate(cohy(nt,nx),cp(nt,nx),a1(nt,nx),dip(nt,nx))
  
  !! read input data in and initialize dip arrays
  
  do i=1,ny
     
   call sep_read(d)
   p1=0.0; p2=0.0
   
   write(0,*) 'Estimating the dip: processing gather #',i,'/',ny
   call puck_jesse_sm(d(:,:),cohx(:,:),px(:,:),residualx(:,:),boxsz)
   p1=px
   
   !make pick output
   mesh2phys=dt/dx
   cp=cmplx(cohx,p1*mesh2phys)
   dip=p1
   
   call sep_write(dip)
   call sep_write(cp,"picks")	

end do

call to_history("n1",nt,"picks") 
call to_history("n2",nx,"picks")
call to_history("n3",ny,"picks")

call to_history("d1",dt,"picks") 
call to_history("d2",dx,"picks")
call to_history("d3",dy,"picks")

call to_history("o1",t0,"picks")
call to_history("o2",x0,"picks")
call to_history("o3",y0,"picks")

end program Puck_3D_sm


















