program Unflatten_w_cube_lint2  !
  !  unflatted a cube with a time slice
  !
  use sep
  use lint1

  implicit none
  integer 	                          :: n1, n2, n3, i1,i2,i3,stat1,diff,ip, ndim
  integer                                 :: knownvec1,knownvec2,data_out_index,subsam, shift_floor, shift_ceil
  integer, dimension (:,:),   allocatable :: knownvec
  real,    dimension (:,:),   allocatable :: data_in,data_out,time_cube,shift_arr
  real, save, pointer, dimension(:)       :: lint_in, lint_out
  real, save, pointer                     :: coord
  real                                    :: shift,iprl, diffrl,shift_diff,upwt,dwnwt
  integer, dimension(:), allocatable      :: n
  real,    dimension(:), allocatable      :: o, d
  real                                    :: thresh


  call sep_init ()
  call sep_init (SOURCE)
  ndim=sep_dimension()
  allocate(o(ndim),d(ndim),n(ndim))
  
  call from_history('n',n)
  call from_history('d',d)
  call from_history('o',o)
  call from_param('thresh',thresh,10000000.)

  write(0,*) 'threshold',thresh
  
  n1=n(1)
  n2=n(2)

  if (ndim.eq.2) then
     n3=1
  else
     n3=n(3)
  end if

  call to_history ("esize",4)
  write(0,*) n1,n2,n3

  subsam=1

  allocate (data_in (n1,n2),time_cube(n1,n2),data_out(n1*subsam,n2))
  allocate (knownvec(n1,n2),shift_arr(n1,n2))  

  do i3=1,n3

     write(0,*) 'Flattening: working on gather',i3,'/',n3 

     call sreed("in", data_in,4*n1*n2)
     call sreed("aux", time_cube,4*n1*n2)
     data_out=0.

     if (minval(time_cube).gt.thresh) then
        write(0,*) 'Bad CMP - replace time-shifts with 0'
        data_out=data_in
        shift_arr=0.
     else

        do i2=1,n2
           do i1=1,n1
              
              data_out_index=(i1)*subsam -1*(subsam-1)     
              shift=subsam*((time_cube(i1,i2)-i1+n1/2)-(time_cube(i1,1)-i1+n1/2))!*mask(n1,n2) !  -5.4   
              !           shift=subsam*((time_cube(i1,i2)-i1+n1/2))!-(time_cube(i1,1)-i1+n1/2))!*mask(n1,n2) !  -5.4       
              shift_floor=floor(shift)  ! -6
              shift_ceil=shift_floor+1 ! -5
              shift_diff=shift-shift_floor !  -5.4 - - 6 =.4
              upwt = shift_diff  !   .4 
              dwnwt= 1-shift_diff !   .6
              
              shift_arr(i1,i2)=shift
              if (data_out_index-shift_floor>n1*subsam-(subsam-1).OR.data_out_index-shift_ceil<1) then
                 !             data_out(data_out_index,i2,i3)=0.
              else
                 knownvec(i1,i2)=data_out_index-shift_floor
                 data_out( data_out_index-shift_floor  ,i2)=data_out( data_out_index-shift_floor  ,i2)+ dwnwt*data_in(i1,i2)
                 data_out( data_out_index-shift_ceil   ,i2)=data_out( data_out_index-shift_ceil   ,i2)+ upwt* data_in(i1,i2)
                 
              end if
           end do
        end do

        do i2=1,n2
           do i1=1,n1-1
              knownvec1=knownvec(i1,i2)
              knownvec2=knownvec(i1+1,i2)
              diff=knownvec2-knownvec1
              if (diff >=3) then
                 do ip=1,diff-2
                    iprl=ip
                    diffrl=diff-1.
!                    data_out(knownvec1+ip,i2)=data_out(knownvec1,i2)*(1.-iprl/diffrl) + data_out(knownvec2-1,i2)*(iprl/diffrl)
                 end do
              end if
           end do
        end do
     end if
     call sep_write (data_out)
     call sep_write (shift_arr,"shift")
     
  end do
  
  call to_history ("n1",   n1*subsam)
  call to_history ("n2",   n2)
  call to_history ("n3",   n3)    
  call to_history ("d1",1./subsam)
  
  call to_history("n1",n1*subsam,"shift") 
  call to_history("n2",n2,"shift")
  call to_history("n3",n3,"shift")
  
  call to_history("d1",d(1),"shift") 
  call to_history("d2",d(2),"shift")
  call to_history("d3",d(3),"shift")
  
  call to_history("o1",o(1),"shift")
  call to_history("o2",o(2),"shift")
  call to_history("o3",o(3),"shift")
  
  call sep_close()
  call exit (0)
  
end program Unflatten_w_cube_lint2














