module weight_mod
  use adj_mod
  implicit none 

  real,    private, dimension(:), pointer :: w

contains
  
  subroutine weight_init(n_in,w_in)
    real, dimension(:) :: w_in 
    integer            :: n_in
    allocate(w(n_in))
    w=w_in
  end subroutine weight_init

  integer function weight_lop( adj, add, model, data)
    logical,intent(in) ::        adj, add
    real, dimension(:) ::                  model, data
    call adjnull (adj,add,model,data)
    call weight_lop2(adj,add,model,data)
    weight_lop = 0
  end function weight_lop
  
  subroutine weight_lop2( adj, add, model, data)
    logical           ::    adj, add
    real, dimension(:)::              model, data

    if (adj) then       
       model = model + w*data    
    else       
       data  = data + w*model      
    end if
    
  end subroutine weight_lop2
  
end module weight_mod

